/*2021-03-01T17:48:00.455Z*/

/**********************************************************************************************************************
 * eFMI_TestCases_M04_DrivetrainTorqueControl_Controllers_Controller.c
 *
 * generated by : embedded software producer/EfmiProductionCodeGen 1.0.0
 *
 * with types :
 *   Boolean   = unsigned int
 *   Integer   = signed int
 *   Real      = float
 *
 * with calling convention :
 *   Arguments = global var (efmiData)
 *   Ret. type = Boolean
 *
 * with names :
 *   Init Fcn  = efmiInitialize
 *   Step Fcn  = efmiDoStep
 *   Recal Fcn = efmiReInitialize
 *
 * with extra comments for :
 *   Code     = true
 *   Location = true
 *
 * with optimizations for :
 *   Indexing = true
 *   Parenth. = true (Misra: true)
 *   Id. len  = -1
 *   Tab size = 4
 *   Line len = 120
 **********************************************************************************************************************/

#include "eFMI_TestCases_M04_DrivetrainTorqueControl_Controllers_Controller.h"

#ifdef __cplusplus
extern "C" {
#endif

#define ALGONAME    "eFMI_TestCases_M04_DrivetrainTorqueControl_Controllers_Controller"
#define ALGOSTRUCT  eFMI_TestCases_M04_DrivetrainTorqueControl_Controllers_Controller_struct

/**********************************************************************************************************************
 * Prototypes
 **********************************************************************************************************************/
static void Recalibrate(ALGOSTRUCT *instance);
static Boolean ESP_cmp_gt(ALGOSTRUCT *instance, Real a, Real b);
static Boolean ESP_cmp_lt(ALGOSTRUCT *instance, Real a, Real b);
static void Startup(ALGOSTRUCT *instance);
static void DoStep(ALGOSTRUCT *instance);

/**********************************************************************************************************************
 * User function(s)
 **********************************************************************************************************************/
static void Recalibrate(ALGOSTRUCT *instance)
{
    /* Saturation */
    if(instance->M_desired < -1000000.0F) {
        instance->M_desired = -1000000.0F;
    }
    else if(instance->M_desired > 1000000.0F) {
        instance->M_desired = 1000000.0F;
    }
    if(instance->wRel < -10000.0F) {
        instance->wRel = -10000.0F;
    }
    else if(instance->wRel > 10000.0F) {
        instance->wRel = 10000.0F;
    }

    /* (258:3) self.'PI.yMin' := -self.tauM_max; */
    instance->PI_yMin = -instance->tauM_max;

    /* (259:3) self.'PI.I.k' := 1.0 / self.Ti_PI; */
    instance->PI_I_k = 1.0F / instance->Ti_PI;

    /* (260:3) self.'PI.gainTrack.k' := 1.0 / (self.k_PI * self.Ni_PI); */
    instance->PI_gainTrack_k = 1.0F / (instance->k_PI * instance->Ni_PI);

    /* (261:3) self.'gear1.k' := 1.0 / self.gearRatio; */
    instance->gear1_k = 1.0F / instance->gearRatio;

    /* (262:3) self.'filter.alpha' := if self.'filter.normalized' then 6.43594252905582698E-01 else 1.0; */
    instance->filter_alpha = instance->filter_normalized ? 0.64359426F : 1.0F;

    /* (263:3) self.'filter.w' := (6.28318530717958623 * self.f_cut) / self.'filter.alpha'; */
    instance->filter_w = (6.2831855F * instance->f_cut) / instance->filter_alpha;

    /* (264:3) self.'approxPlant.driveline.J_M' := self.J_M / (self.gearRatio * self.gearRatio); */
    instance->approxPlant_driveline_J_M = instance->J_M / (instance->gearRatio * instance->gearRatio);

    /* Saturation */
    if(instance->M_motor < -1000000.0F) {
        instance->M_motor = -1000000.0F;
    }
    else if(instance->M_motor > 1000000.0F) {
        instance->M_motor = 1000000.0F;
    }
}

static Boolean ESP_cmp_gt(ALGOSTRUCT *instance, Real a, Real b)
{
    /* Output variable */
    Boolean y;

    if(isNaN(a) || isNaN(b)) {
        instance->ErrorSignals |= ErrorSignal_NAN;
        y = false;
    } else {
        y = a > b;
    }

    return y;
}

static Boolean ESP_cmp_lt(ALGOSTRUCT *instance, Real a, Real b)
{
    /* Output variable */
    Boolean y;

    if(isNaN(a) || isNaN(b)) {
        instance->ErrorSignals |= ErrorSignal_NAN;
        y = false;
    } else {
        y = a < b;
    }

    return y;
}

static void Startup(ALGOSTRUCT *instance)
{
    /* Local variable(s) */
    Real solution_buffer_for_x;

    /* Saturation */
    if(instance->M_desired < -1000000.0F) {
        instance->M_desired = -1000000.0F;
    }
    else if(instance->M_desired > 1000000.0F) {
        instance->M_desired = 1000000.0F;
    }
    if(instance->wRel < -10000.0F) {
        instance->wRel = -10000.0F;
    }
    else if(instance->wRel > 10000.0F) {
        instance->wRel = 10000.0F;
    }

    /* (153:3) self.'discrete.stepSize' := 5.0000000000000001E-04; */
    instance->discrete_stepSize = 5.0E-4F;

    // ***************************************** Initialize variables without explicit start value (implicit initializations):

    /* (156:3) self.M_desired := 0.0; */
    instance->M_desired = 0.0F;

    /* (157:3) self.wRel := 0.0; */
    instance->wRel = 0.0F;

    /* (158:3) self.M_motor := 0.0; */
    instance->M_motor = 0.0F;

    /* (159:3) self.'derivative(filter.x[1])' := 0.0; */
    instance->der_filter_x_1 = 0.0F;

    /* (160:3) self.'derivative(PI.I.y)' := 0.0; */
    instance->der_PI_I_y = 0.0F;

    /* (161:3) self.'PI.addSat.y' := 0.0; */
    instance->PI_addSat_y = 0.0F;

    /* (162:3) self.'PI.addI.u3' := 0.0; */
    instance->PI_addI_u3 = 0.0F;

    /* (163:3) self.'PI.I.u' := 0.0; */
    instance->PI_I_u = 0.0F;

    // ************************************** Initialize independent variables (explicit literal-value based initializations):

    /* (166:3) self.k_accCor := -1.01615216387814008E-02; */
    instance->k_accCor = -0.010161522F;

    /* (167:3) self.c_res := 4.71E+03; */
    instance->c_res = 4710.0F;

    /* (168:3) self.'approxPlant.driveline.Gear.phi_rel0' := 0.0; */
    instance->approxPlant_driveline_Gear_phi_rel0 = 0.0F;

    /* (169:3) self.d_res := 1.57000000000000006; */
    instance->d_res = 1.57F;

    /* (170:3) self.gearRatio := 1.0E+01; */
    instance->gearRatio = 10.0F;

    /* (171:3) self.'PI.wp' := 1.0; */
    instance->PI_wp = 1.0F;

    /* (172:3) self.'PI.addP.k2' := -1.0; */
    instance->PI_addP_k2 = -1.0F;

    /* (173:3) self.'PI.P.k' := 1.0; */
    instance->PI_P_k = 1.0F;

    /* (174:3) self.'PI.addPI.k1' := 1.0; */
    instance->PI_addPI_k1 = 1.0F;

    /* (175:3) self.'PI.addPI.k2' := 1.0; */
    instance->PI_addPI_k2 = 1.0F;

    /* (176:3) self.k_PI := -7.3E+01; */
    instance->k_PI = -73.0F;

    /* (177:3) self.'PI.add_ff.k1' := 1.0; */
    instance->PI_add_ff_k1 = 1.0F;

    /* (178:3) self.'PI.add_ff.k2' := 1.0; */
    instance->PI_add_ff_k2 = 1.0F;

    /* (179:3) self.tauM_max := 1.23E+03; */
    instance->tauM_max = 1230.0F;

    /* (180:3) self.'PI.addSat.k1' := -1.0; */
    instance->PI_addSat_k1 = -1.0F;

    /* (181:3) self.'PI.addSat.k2' := 1.0; */
    instance->PI_addSat_k2 = 1.0F;

    /* (182:3) self.'PI.addI.k1' := 1.0; */
    instance->PI_addI_k1 = 1.0F;

    /* (183:3) self.'PI.addI.k2' := -1.0; */
    instance->PI_addI_k2 = -1.0F;

    /* (184:3) self.'PI.addI.k3' := 1.0; */
    instance->PI_addI_k3 = 1.0F;

    /* (185:3) self.'filter.x_start[2]' := 0.0; */
    instance->filter_x_start_2 = 0.0F;

    /* (186:3) self.'filter.x_start[1]' := 0.0; */
    instance->filter_x_start_1 = 0.0F;

    /* (187:3) self.'PI.xi_start' := 0.0; */
    instance->PI_xi_start = 0.0F;

    /* (188:3) self.J_M := 1.00000000000000002E-02; */
    instance->J_M = 0.01F;

    /* (189:3) self.f_cut := 3.3E+01; */
    instance->f_cut = 33.0F;

    /* (190:3) self.'filter.normalized' := true; */
    instance->filter_normalized = true;

    /* (191:3) self.Ni_PI := 1.34000000000000008; */
    instance->Ni_PI = 1.34F;

    /* (192:3) self.Ti_PI := 1.25; */
    instance->Ti_PI = 1.25F;

    // *************************************** Initialize dependend parameters (constant and parameter based initializations):

    /* (195:3) () := Recalibrate(); */
    Recalibrate(instance);

    // ***************** Initialize start-value fixed variables (literal-value, constant and parameter based initializations):

    /* (198:3) self.'filter.x[2]' := self.'filter.x_start[2]'; */
    instance->filter_x_2 = instance->filter_x_start_2;

    /* (199:3) self.'approxPlant.driveline.Gear.phi_rel' := 0.0; */
    instance->approxPlant_driveline_Gear_phi_rel = 0.0F;

    /* (200:3) self.'filter.x[1]' := self.'filter.x_start[1]'; */
    instance->filter_x_1 = instance->filter_x_start_1;

    /* (201:3) self.'PI.I.y' := self.'PI.xi_start'; */
    instance->PI_I_y = instance->PI_xi_start;

    // ****************************** Initialize dependent variables (constant, parameter and variable based initializations):

    /* (204:3) self.'derivative(filter.x[2])' := (self.'filter.x[1]' - self.'filter.x[2]') * self.'filter.w'; */
    instance->der_filter_x_2 = (instance->filter_x_1 - instance->filter_x_2) * instance->filter_w;

    /* (205:3) self.'derivative(approxPlant.torqueDist.flange.tau)' := -self.k_accCor * self.'derivative(filter.x[2])'; */
    instance->der_approxPlant_torqueDist_flange_tau = -(instance->k_accCor * instance->der_filter_x_2);

    /* (206:3) self.'derivative(approxPlant.driveline.flange_b.tau)' := -self.'derivative(filter.x[2])' + self.'derivative(approxPlant.torqueDist.flange.tau)'; */
    instance->der_approxPlant_driveline_flange_b_tau = -(instance->der_filter_x_2 + instance->der_approxPlant_torqueDist_flange_tau);

    /* (207:3) self.'approxPlant.torqueDist.flange.tau' := -self.k_accCor * self.'filter.x[2]'; */
    instance->approxPlant_torqueDist_flange_tau = -(instance->k_accCor * instance->filter_x_2);

    /* (208:3) self.'approxPlant.driveline.flange_b.tau' := -self.'filter.x[2]' + self.'approxPlant.torqueDist.flange.tau'; */
    instance->approxPlant_driveline_flange_b_tau = -(instance->filter_x_2 + instance->approxPlant_torqueDist_flange_tau);

    /* (209:3) self.'approxPlant.driveline.Gear.tau_c' := self.c_res * (self.'approxPlant.driveline.Gear.phi_rel' - self.'approxPlant.driveline.Gear.phi_rel0'); */
    instance->approxPlant_driveline_Gear_tau_c = instance->c_res * (instance->approxPlant_driveline_Gear_phi_rel - instance->approxPlant_driveline_Gear_phi_rel0);

    /* (210:3) self.'approxPlant.driveline.Gear.tau_d' := self.'approxPlant.driveline.flange_b.tau' - self.'approxPlant.driveline.Gear.tau_c'; */
    instance->approxPlant_driveline_Gear_tau_d = instance->approxPlant_driveline_flange_b_tau - instance->approxPlant_driveline_Gear_tau_c;

    /* (211:3) 'solution_buffer.for.x' := self.'approxPlant.driveline.Gear.tau_d' / self.d_res; */
    solution_buffer_for_x = instance->approxPlant_driveline_Gear_tau_d / instance->d_res;

    /* (212:3) if isNaN('solution_buffer.for.x') or isInfinite('solution_buffer.for.x') then... */
    if(isNaN(solution_buffer_for_x) || isInfinite(solution_buffer_for_x)) {
        // Set state to default start-value and signal error:

        /* (214:4) self.'derivative(approxPlant.driveline.Gear.phi_rel)' := 0.0; */
        instance->der_approxPlant_driveline_Gear_phi_rel = 0.0F;

        /* (215:4) signal SOLVE_LINEAR_EQUATIONS_FAILED */
        instance->ErrorSignals |= ErrorSignal_SOLVE_LINEAR_EQUATIONS_FAILED;
    } else {
        // Only if the system can be solved, assign computed state:

        /* (218:4) self.'derivative(approxPlant.driveline.Gear.phi_rel)' := 'solution_buffer.for.x'; */
        instance->der_approxPlant_driveline_Gear_phi_rel = solution_buffer_for_x;
    }

    /* (220:3) self.'derivative(approxPlant.driveline.Gear.tau_c)' := self.c_res * self.'derivative(approxPlant.driveline.Gear.phi_rel)'; */
    instance->der_approxPlant_driveline_Gear_tau_c = instance->c_res * instance->der_approxPlant_driveline_Gear_phi_rel;

    /* (221:3) self.'derivative(approxPlant.driveline.Gear.tau_d)' := self.'derivative(approxPlant.driveline.flange_b.tau)' - self.'derivative(approxPlant.driveline.Gear.tau_c)'; */
    instance->der_approxPlant_driveline_Gear_tau_d = instance->der_approxPlant_driveline_flange_b_tau - instance->der_approxPlant_driveline_Gear_tau_c;

    /* (222:3) 'solution_buffer.for.x' := self.'derivative(approxPlant.driveline.Gear.tau_d)' / self.d_res; */
    solution_buffer_for_x = instance->der_approxPlant_driveline_Gear_tau_d / instance->d_res;

    /* (223:3) if isNaN('solution_buffer.for.x') or isInfinite('solution_buffer.for.x') then... */
    if(isNaN(solution_buffer_for_x) || isInfinite(solution_buffer_for_x)) {
        // Set state to default start-value and signal error:

        /* (225:4) self.'derivative(approxPlant.driveline.Gear.w_rel)' := 0.0; */
        instance->der_approxPlant_driveline_Gear_w_rel = 0.0F;

        /* (226:4) signal SOLVE_LINEAR_EQUATIONS_FAILED */
        instance->ErrorSignals |= ErrorSignal_SOLVE_LINEAR_EQUATIONS_FAILED;
    } else {
        // Only if the system can be solved, assign computed state:

        /* (229:4) self.'derivative(approxPlant.driveline.Gear.w_rel)' := 'solution_buffer.for.x'; */
        instance->der_approxPlant_driveline_Gear_w_rel = solution_buffer_for_x;
    }

    /* (231:3) self.'derivative(approxPlant.driveline.inertiaDrivelineIn.w)' := -self.gearRatio * self.'derivative(approxPlant.driveline.Gear.w_rel)'; */
    instance->der_approxPlant_driveline_inertiaDrivelineIn_w = -(instance->gearRatio * instance->der_approxPlant_driveline_Gear_w_rel);

    /* (232:3) 'solution_buffer.for.x' := self.'approxPlant.driveline.flange_b.tau' / self.gearRatio; */
    solution_buffer_for_x = instance->approxPlant_driveline_flange_b_tau / instance->gearRatio;

    /* (233:3) if isNaN('solution_buffer.for.x') or isInfinite('solution_buffer.for.x') then... */
    if(isNaN(solution_buffer_for_x) || isInfinite(solution_buffer_for_x)) {
        // Set state to default start-value and signal error:

        /* (235:4) self.'approxPlant.driveline.inertiaDrivelineIn.flange_b.tau' := 0.0; */
        instance->approxPlant_driveline_inertiaDrivelineIn_flange_b_tau = 0.0F;

        /* (236:4) signal SOLVE_LINEAR_EQUATIONS_FAILED */
        instance->ErrorSignals |= ErrorSignal_SOLVE_LINEAR_EQUATIONS_FAILED;
    } else {
        // Only if the system can be solved, assign computed state:

        /* (239:4) self.'approxPlant.driveline.inertiaDrivelineIn.flange_b.tau' := 'solution_buffer.for.x'; */
        instance->approxPlant_driveline_inertiaDrivelineIn_flange_b_tau = solution_buffer_for_x;
    }

    /* (241:3) self.'gear.u' := (self.'approxPlant.driveline.J_M' * self.'derivative(approxPlant.driveline.inertiaDrivelineIn.w)') - self.'approxPlant.driveline.inertiaDrivelineIn.flange_b.tau'; */
    instance->gear_u = (instance->approxPlant_driveline_J_M * instance->der_approxPlant_driveline_inertiaDrivelineIn_w) \
        - instance->approxPlant_driveline_inertiaDrivelineIn_flange_b_tau;

    /* (242:3) self.'gear.y' := self.gearRatio * self.'gear.u'; */
    instance->gear_y = instance->gearRatio * instance->gear_u;

    /* (243:3) self.'PI.addP.y' := (self.'PI.wp' * self.'derivative(approxPlant.driveline.Gear.phi_rel)') + (self.'PI.addP.k2' * self.wRel); */
    instance->PI_addP_y = (instance->PI_wp * instance->der_approxPlant_driveline_Gear_phi_rel) + (instance->PI_addP_k2 \
        * instance->wRel);

    /* (244:3) self.'PI.P.y' := self.'PI.P.k' * self.'PI.addP.y'; */
    instance->PI_P_y = instance->PI_P_k * instance->PI_addP_y;

    /* (245:3) self.'PI.gainPI.u' := (self.'PI.addPI.k1' * self.'PI.P.y') + (self.'PI.addPI.k2' * self.'PI.I.y'); */
    instance->PI_gainPI_u = (instance->PI_addPI_k1 * instance->PI_P_y) + (instance->PI_addPI_k2 * instance->PI_I_y);

    /* (246:3) self.'PI.gainPI.y' := self.k_PI * self.'PI.gainPI.u'; */
    instance->PI_gainPI_y = instance->k_PI * instance->PI_gainPI_u;

    /* (247:3) self.'PI.limiter.u' := (self.'PI.add_ff.k1' * self.'gear.y') + (self.'PI.add_ff.k2' * self.'PI.gainPI.y'); */
    instance->PI_limiter_u = (instance->PI_add_ff_k1 * instance->gear_y) + (instance->PI_add_ff_k2 * instance->PI_gainPI_y);

    /* (248:3) self.'PI.y' := if self.'PI.limiter.u' > self.tauM_max then self.tauM_max elseif self.'PI.limiter.u' < self.'PI.yMin' self.'PI.yMin' else self.'PI.limiter.u'; */
    instance->PI_y = ESP_cmp_gt(instance, instance->PI_limiter_u, instance->tauM_max) ? instance->tauM_max : ESP_cmp_lt(instance, \
        instance->PI_limiter_u, instance->PI_yMin) ? instance->PI_yMin : instance->PI_limiter_u;

    /* Saturation */
    if(instance->M_motor < -1000000.0F) {
        instance->M_motor = -1000000.0F;
    }
    else if(instance->M_motor > 1000000.0F) {
        instance->M_motor = 1000000.0F;
    }
}

static void DoStep(ALGOSTRUCT *instance)
{
    /* Local variable(s) */
    Real solution_buffer_for_x;

    /* Saturation */
    if(instance->M_desired < -1000000.0F) {
        instance->M_desired = -1000000.0F;
    }
    else if(instance->M_desired > 1000000.0F) {
        instance->M_desired = 1000000.0F;
    }
    if(instance->wRel < -10000.0F) {
        instance->wRel = -10000.0F;
    }
    else if(instance->wRel > 10000.0F) {
        instance->wRel = 10000.0F;
    }

    // ****************************************************************************** Update-equations for inline integration:

    /* (280:3) self.'filter.x[2]' := self.'filter.x[2]' + (self.'discrete.stepSize' * self.'derivative(filter.x[2])'); */
    instance->filter_x_2 += instance->discrete_stepSize * instance->der_filter_x_2;

    /* (281:3) self.'approxPlant.driveline.Gear.phi_rel' := self.'approxPlant.driveline.Gear.phi_rel' + (self.'discrete.stepSize' * self.'derivative(approxPlant.driveline.Gear.phi_rel)'); */
    instance->approxPlant_driveline_Gear_phi_rel += instance->discrete_stepSize * instance->der_approxPlant_driveline_Gear_phi_rel;

    /* (282:3) self.'filter.x[1]' := self.'filter.x[1]' + (self.'discrete.stepSize' * self.'derivative(filter.x[1])'); */
    instance->filter_x_1 += instance->discrete_stepSize * instance->der_filter_x_1;

    /* (283:3) self.'PI.I.y' := self.'PI.I.y' + (self.'discrete.stepSize' * self.'derivative(PI.I.y)'); */
    instance->PI_I_y += instance->discrete_stepSize * instance->der_PI_I_y;

    // ******************************************************************************************** Input-independent outputs:

    /* (286:3) self.'derivative(filter.x[2])' := (self.'filter.x[1]' - self.'filter.x[2]') * self.'filter.w'; */
    instance->der_filter_x_2 = (instance->filter_x_1 - instance->filter_x_2) * instance->filter_w;

    /* (287:3) self.'derivative(approxPlant.torqueDist.flange.tau)' := -self.k_accCor * self.'derivative(filter.x[2])'; */
    instance->der_approxPlant_torqueDist_flange_tau = -(instance->k_accCor * instance->der_filter_x_2);

    /* (288:3) self.'derivative(approxPlant.driveline.flange_b.tau)' := -self.'derivative(filter.x[2])' + self.'derivative(approxPlant.torqueDist.flange.tau)'; */
    instance->der_approxPlant_driveline_flange_b_tau = -(instance->der_filter_x_2 + instance->der_approxPlant_torqueDist_flange_tau);

    /* (289:3) self.'approxPlant.torqueDist.flange.tau' := -self.k_accCor * self.'filter.x[2]'; */
    instance->approxPlant_torqueDist_flange_tau = -(instance->k_accCor * instance->filter_x_2);

    /* (290:3) self.'approxPlant.driveline.flange_b.tau' := -self.'filter.x[2]' + self.'approxPlant.torqueDist.flange.tau'; */
    instance->approxPlant_driveline_flange_b_tau = -(instance->filter_x_2 + instance->approxPlant_torqueDist_flange_tau);

    /* (291:3) self.'approxPlant.driveline.Gear.tau_c' := self.c_res * (self.'approxPlant.driveline.Gear.phi_rel' - self.'approxPlant.driveline.Gear.phi_rel0'); */
    instance->approxPlant_driveline_Gear_tau_c = instance->c_res * (instance->approxPlant_driveline_Gear_phi_rel - instance->approxPlant_driveline_Gear_phi_rel0);

    /* (292:3) self.'approxPlant.driveline.Gear.tau_d' := self.'approxPlant.driveline.flange_b.tau' - self.'approxPlant.driveline.Gear.tau_c'; */
    instance->approxPlant_driveline_Gear_tau_d = instance->approxPlant_driveline_flange_b_tau - instance->approxPlant_driveline_Gear_tau_c;

    /* (293:3) 'solution_buffer.for.x' := self.'approxPlant.driveline.Gear.tau_d' / self.d_res; */
    solution_buffer_for_x = instance->approxPlant_driveline_Gear_tau_d / instance->d_res;

    /* (294:3) if isNaN('solution_buffer.for.x') or isInfinite('solution_buffer.for.x') then... */
    if(isNaN(solution_buffer_for_x) || isInfinite(solution_buffer_for_x)) {
        // Signal error but leave state as it is:

        /* (296:4) signal SOLVE_LINEAR_EQUATIONS_FAILED */
        instance->ErrorSignals |= ErrorSignal_SOLVE_LINEAR_EQUATIONS_FAILED;
    } else {
        // Only if the system can be solved, assign computed state:

        /* (299:4) self.'derivative(approxPlant.driveline.Gear.phi_rel)' := 'solution_buffer.for.x'; */
        instance->der_approxPlant_driveline_Gear_phi_rel = solution_buffer_for_x;
    }

    /* (301:3) self.'derivative(approxPlant.driveline.Gear.tau_c)' := self.c_res * self.'derivative(approxPlant.driveline.Gear.phi_rel)'; */
    instance->der_approxPlant_driveline_Gear_tau_c = instance->c_res * instance->der_approxPlant_driveline_Gear_phi_rel;

    /* (302:3) self.'derivative(approxPlant.driveline.Gear.tau_d)' := self.'derivative(approxPlant.driveline.flange_b.tau)' - self.'derivative(approxPlant.driveline.Gear.tau_c)'; */
    instance->der_approxPlant_driveline_Gear_tau_d = instance->der_approxPlant_driveline_flange_b_tau - instance->der_approxPlant_driveline_Gear_tau_c;

    /* (303:3) 'solution_buffer.for.x' := self.'derivative(approxPlant.driveline.Gear.tau_d)' / self.d_res; */
    solution_buffer_for_x = instance->der_approxPlant_driveline_Gear_tau_d / instance->d_res;

    /* (304:3) if isNaN('solution_buffer.for.x') or isInfinite('solution_buffer.for.x') then... */
    if(isNaN(solution_buffer_for_x) || isInfinite(solution_buffer_for_x)) {
        // Signal error but leave state as it is:

        /* (306:4) signal SOLVE_LINEAR_EQUATIONS_FAILED */
        instance->ErrorSignals |= ErrorSignal_SOLVE_LINEAR_EQUATIONS_FAILED;
    } else {
        // Only if the system can be solved, assign computed state:

        /* (309:4) self.'derivative(approxPlant.driveline.Gear.w_rel)' := 'solution_buffer.for.x'; */
        instance->der_approxPlant_driveline_Gear_w_rel = solution_buffer_for_x;
    }

    /* (311:3) self.'derivative(approxPlant.driveline.inertiaDrivelineIn.w)' := -self.gearRatio * self.'derivative(approxPlant.driveline.Gear.w_rel)'; */
    instance->der_approxPlant_driveline_inertiaDrivelineIn_w = -(instance->gearRatio * instance->der_approxPlant_driveline_Gear_w_rel);

    /* (312:3) 'solution_buffer.for.x' := self.'approxPlant.driveline.flange_b.tau' / self.gearRatio; */
    solution_buffer_for_x = instance->approxPlant_driveline_flange_b_tau / instance->gearRatio;

    /* (313:3) if isNaN('solution_buffer.for.x') or isInfinite('solution_buffer.for.x') then... */
    if(isNaN(solution_buffer_for_x) || isInfinite(solution_buffer_for_x)) {
        // Signal error but leave state as it is:

        /* (315:4) signal SOLVE_LINEAR_EQUATIONS_FAILED */
        instance->ErrorSignals |= ErrorSignal_SOLVE_LINEAR_EQUATIONS_FAILED;
    } else {
        // Only if the system can be solved, assign computed state:

        /* (318:4) self.'approxPlant.driveline.inertiaDrivelineIn.flange_b.tau' := 'solution_buffer.for.x'; */
        instance->approxPlant_driveline_inertiaDrivelineIn_flange_b_tau = solution_buffer_for_x;
    }

    /* (320:3) self.'gear.u' := (self.'approxPlant.driveline.J_M' * self.'derivative(approxPlant.driveline.inertiaDrivelineIn.w)') - self.'approxPlant.driveline.inertiaDrivelineIn.flange_b.tau'; */
    instance->gear_u = (instance->approxPlant_driveline_J_M * instance->der_approxPlant_driveline_inertiaDrivelineIn_w) \
        - instance->approxPlant_driveline_inertiaDrivelineIn_flange_b_tau;

    /* (321:3) self.'gear.y' := self.gearRatio * self.'gear.u'; */
    instance->gear_y = instance->gearRatio * instance->gear_u;

    // ********************************************************************************************** Input-dependent outputs:

    /* (324:3) self.'PI.addP.y' := (self.'PI.wp' * self.'derivative(approxPlant.driveline.Gear.phi_rel)') + (self.'PI.addP.k2' * self.wRel); */
    instance->PI_addP_y = (instance->PI_wp * instance->der_approxPlant_driveline_Gear_phi_rel) + (instance->PI_addP_k2 \
        * instance->wRel);

    /* (325:3) self.'PI.P.y' := self.'PI.P.k' * self.'PI.addP.y'; */
    instance->PI_P_y = instance->PI_P_k * instance->PI_addP_y;

    /* (326:3) self.'PI.gainPI.u' := (self.'PI.addPI.k1' * self.'PI.P.y') + (self.'PI.addPI.k2' * self.'PI.I.y'); */
    instance->PI_gainPI_u = (instance->PI_addPI_k1 * instance->PI_P_y) + (instance->PI_addPI_k2 * instance->PI_I_y);

    /* (327:3) self.'PI.gainPI.y' := self.k_PI * self.'PI.gainPI.u'; */
    instance->PI_gainPI_y = instance->k_PI * instance->PI_gainPI_u;

    /* (328:3) self.'PI.limiter.u' := (self.'PI.add_ff.k1' * self.'gear.y') + (self.'PI.add_ff.k2' * self.'PI.gainPI.y'); */
    instance->PI_limiter_u = (instance->PI_add_ff_k1 * instance->gear_y) + (instance->PI_add_ff_k2 * instance->PI_gainPI_y);

    /* (329:3) self.'PI.y' := if self.'PI.limiter.u' > self.tauM_max then self.tauM_max elseif self.'PI.limiter.u' < self.'PI.yMin' self.'PI.yMin' else self.'PI.limiter.u'; */
    instance->PI_y = ESP_cmp_gt(instance, instance->PI_limiter_u, instance->tauM_max) ? instance->tauM_max : ESP_cmp_lt(instance, \
        instance->PI_limiter_u, instance->PI_yMin) ? instance->PI_yMin : instance->PI_limiter_u;

    /* (330:3) self.M_motor := self.'gear1.k' * self.'PI.y'; */
    instance->M_motor = instance->gear1_k * instance->PI_y;

    // ************************************ Next step preparations (without effect on the output of this step, but only next):

    /* (333:3) self.'derivative(filter.x[1])' := (self.M_desired - self.'filter.x[1]') * self.'filter.w'; */
    instance->der_filter_x_1 = (instance->M_desired - instance->filter_x_1) * instance->filter_w;

    /* (334:3) self.'PI.addSat.y' := (self.'PI.addSat.k1' * self.'PI.limiter.u') + (self.'PI.addSat.k2' * self.'PI.y'); */
    instance->PI_addSat_y = (instance->PI_addSat_k1 * instance->PI_limiter_u) + (instance->PI_addSat_k2 * instance->PI_y);

    /* (335:3) self.'PI.addI.u3' := self.'PI.gainTrack.k' * self.'PI.addSat.y'; */
    instance->PI_addI_u3 = instance->PI_gainTrack_k * instance->PI_addSat_y;

    /* (336:3) self.'PI.I.u' := ((self.'PI.addI.k1' * self.'derivative(approxPlant.driveline.Gear.phi_rel)') + (self.'PI.addI.k2' * self.wRel)) + (self.'PI.addI.k3' * self.'PI.addI.u3'); */
    instance->PI_I_u = (instance->PI_addI_k1 * instance->der_approxPlant_driveline_Gear_phi_rel) + (instance->PI_addI_k2 \
        * instance->wRel) + (instance->PI_addI_k3 * instance->PI_addI_u3);

    /* (337:3) self.'derivative(PI.I.y)' := self.'PI.I.k' * self.'PI.I.u'; */
    instance->der_PI_I_y = instance->PI_I_k * instance->PI_I_u;

    /* Saturation */
    if(instance->M_motor < -1000000.0F) {
        instance->M_motor = -1000000.0F;
    }
    else if(instance->M_motor > 1000000.0F) {
        instance->M_motor = 1000000.0F;
    }
}

/**********************************************************************************************************************
 * init
 **********************************************************************************************************************/
void _basic_eFMI_TestCases_M04_DrivetrainTorqueControl_Controllers_Controller_init(ALGOSTRUCT *instance) {
    instance->ErrorSignals = ErrorSignal_NONE;
    Startup(instance);
}

/**********************************************************************************************************************
 * step
 **********************************************************************************************************************/
void _basic_eFMI_TestCases_M04_DrivetrainTorqueControl_Controllers_Controller_step(ALGOSTRUCT *instance) {
    instance->ErrorSignals = ErrorSignal_NONE;
    DoStep(instance);
}

/**********************************************************************************************************************
 * recalibrate
 **********************************************************************************************************************/
void _basic_eFMI_TestCases_M04_DrivetrainTorqueControl_Controllers_Controller_recalibrate(ALGOSTRUCT *instance) {
    instance->ErrorSignals = ErrorSignal_NONE;
    Recalibrate(instance);
}

#ifdef __cplusplus
}
#endif

/* end of file */
