/*2021-03-01T17:48:00.452Z*/

/**********************************************************************************************************************
 * eFMI_TestCases_M04_DrivetrainTorqueControl_Controllers_Controller.h
 *
 * generated by : embedded software producer/EfmiProductionCodeGen 1.0.0
 *
 * with types :
 *   Boolean   = unsigned int
 *   Integer   = signed int
 *   Real      = float
 *
 * with calling convention :
 *   Arguments = global var (efmiData)
 *   Ret. type = Boolean
 *
 * with names :
 *   Init Fcn  = efmiInitialize
 *   Step Fcn  = efmiDoStep
 *   Recal Fcn = efmiReInitialize
 *
 * with extra comments for :
 *   Code     = true
 *   Location = true
 *
 * with optimizations for :
 *   Indexing = true
 *   Parenth. = true (Misra: true)
 *   Id. len  = -1
 *   Tab size = 4
 *   Line len = 120
 **********************************************************************************************************************/

#ifndef EFMI_TESTCASES_M04_DRIVETRAINTORQUECONTROL_CONTROLLERS_CONTROLLER_H
#define EFMI_TESTCASES_M04_DRIVETRAINTORQUECONTROL_CONTROLLERS_CONTROLLER_H

#ifdef __cplusplus
extern "C" {
#endif

#include "esp_alg.h"

/**********************************************************************************************************************
 * structure declaration
 **********************************************************************************************************************/
typedef struct {
    /* Signals */
    ErrorSignal ErrorSignals;

    /* Ports */
    Real M_desired;
    Real wRel;
    Real M_motor;

    /* Parameters */
    Real J_M;
    Real Ni_PI;
    Real Ti_PI;
    Real c_res;
    Real d_res;
    Real f_cut;
    Real gearRatio;
    Real k_PI;
    Real k_accCor;
    Real tauM_max;
    Real PI_yMin;
    Real PI_I_k;
    Real PI_gainTrack_k;
    Real approxPlant_driveline_J_M;
    Real filter_alpha;
    Real filter_w;
    Real gear1_k;

    /* Constants */
    Real    PI_wp;
    Real    PI_xi_start;
    Real    PI_P_k;
    Real    PI_addI_k1;
    Real    PI_addI_k2;
    Real    PI_addI_k3;
    Real    PI_addP_k2;
    Real    PI_addPI_k1;
    Real    PI_addPI_k2;
    Real    PI_addSat_k1;
    Real    PI_addSat_k2;
    Real    PI_add_ff_k1;
    Real    PI_add_ff_k2;
    Real    approxPlant_driveline_Gear_phi_rel0;
    Boolean filter_normalized;
    Real    filter_x_start_1;
    Real    filter_x_start_2;
    Real    discrete_stepSize;

    /* States */
    Real PI_y;
    Real der_PI_I_y;
    Real PI_I_u;
    Real PI_I_y;
    Real PI_P_y;
    Real PI_addI_u3;
    Real PI_addP_y;
    Real PI_addSat_y;
    Real PI_gainPI_u;
    Real PI_gainPI_y;
    Real PI_limiter_u;
    Real der_approxPlant_driveline_Gear_phi_rel;
    Real der_approxPlant_driveline_Gear_tau_c;
    Real der_approxPlant_driveline_Gear_tau_d;
    Real der_approxPlant_driveline_Gear_w_rel;
    Real approxPlant_driveline_Gear_phi_rel;
    Real approxPlant_driveline_Gear_tau_c;
    Real approxPlant_driveline_Gear_tau_d;
    Real der_approxPlant_driveline_flange_b_tau;
    Real approxPlant_driveline_flange_b_tau;
    Real der_approxPlant_driveline_inertiaDrivelineIn_w;
    Real approxPlant_driveline_inertiaDrivelineIn_flange_b_tau;
    Real der_approxPlant_torqueDist_flange_tau;
    Real approxPlant_torqueDist_flange_tau;
    Real der_filter_x_1;
    Real der_filter_x_2;
    Real filter_x_1;
    Real filter_x_2;
    Real gear_u;
    Real gear_y;
} eFMI_TestCases_M04_DrivetrainTorqueControl_Controllers_Controller_struct;

void _basic_eFMI_TestCases_M04_DrivetrainTorqueControl_Controllers_Controller_init(eFMI_TestCases_M04_DrivetrainTorqueControl_Controllers_Controller_struct \
    *instance);
void _basic_eFMI_TestCases_M04_DrivetrainTorqueControl_Controllers_Controller_step(eFMI_TestCases_M04_DrivetrainTorqueControl_Controllers_Controller_struct \
    *instance);
void _basic_eFMI_TestCases_M04_DrivetrainTorqueControl_Controllers_Controller_recalibrate(eFMI_TestCases_M04_DrivetrainTorqueControl_Controllers_Controller_struct \
    *instance);

#ifdef __cplusplus
}
#endif

#endif /* EFMI_TESTCASES_M04_DRIVETRAINTORQUECONTROL_CONTROLLERS_CONTROLLER_H */
/* end of file */
